<?php
namespace App\Repositories;


use App\Exceptions\NotPendingException;
use App\Models\Request;
use App\Repositories\Generic\Repository;

class RequestRepository extends Repository
{
    function model()
    {
       return 'App\Models\Request';
    }
    //PAGINATE
    public function paginate($perPage, $userId = null, $status = null, $columns = array('*'))
    {
        //dd($userId);
        $requests = Request::query()->with('user');

        if (!empty($userId)) {
            $requests = $requests->where('user_id', $userId);
        }

        if (!empty($status)) {
            $requests = $requests->byStatus($status);
        }

        $requests = $requests->orderBy('id')->paginate(10);
        return $requests;
    }
    //UPDATE
    public function update(array $data, $id, $response = false)
    {
        $requests = Request::where('id', $id);
        if (!empty($response)) {
            $requests = $requests->first();
        }
        if ($requests->status !== Request::REQ_STAT_PEN)
        {
            throw new NotPendingException();
        }
        return parent::update($data, $id); // TODO: Change the autogenerated stub
    }
}